package com.pjaol.ifodder;


import java.io.FileNotFoundException;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import com.pjaol.ifodder.application.ApplicationHandler;
import com.pjaol.ifodder.config.ConfigHandler;

public class Initialization extends HttpServlet {

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Logger _log = Logger.getLogger(getClass());
	/**
	 * Destruction of the servlet. <br>
	 */
	public void destroy() {
		super.destroy(); // Just puts "destroy" string in log
		// Put your code here
	}

	/**
	 * Initialization of the servlet. <br>
	 *
	 * @throws ServletException if an error occure
	 */
	public void init() throws ServletException {
		
		// load log4j manually
		String log4j = getInitParameter("log4j");
		log4j = getServletContext().getRealPath(log4j);
		PropertyConfigurator.configure(log4j);
		
		
		// load configuration
		String config = getInitParameter("configFile");
		config = getServletContext().getRealPath(config);
		_log.info("Loading config file "+config );
		try {
			new ConfigHandler(config);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		String storageClass = ConfigHandler.getConfig("storage.class");
		_log.info("Setting storage mechanism to "+ storageClass);
		
		try {
			new ApplicationHandler().setStorage(storageClass);
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		
		String retrivalClass = ConfigHandler.getConfig("retrival.class");
		_log.info("Setting the retrival mechanism to "+ retrivalClass);
		
		try {
			new ApplicationHandler().setRetrival(retrivalClass);
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

}
