package com.pjaol.ifodder.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.pjaol.ifodder.application.ApplicationHandler;
import com.pjaol.ifodder.storage.StorageException;

public class WebHandler extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Destruction of the servlet. <br>
	 */
	public void destroy() {
		super.destroy(); // Just puts "destroy" string in log
		// Put your code here
	}

	/**
	 * The doGet method of the servlet. <br>
	 *
	 * This method is called when a form has its tag value method equals to get.
	 * 
	 * @param request the request send by the client to the server
	 * @param response the response send by the server to the client
	 * @throws ServletException if an error occurred
	 * @throws IOException if an error occurred
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		handleRequest(request, response);

	}

	/**
	 * The doPost method of the servlet. <br>
	 *
	 * This method is called when a form has its tag value method equals to post.
	 * 
	 * @param request the request send by the client to the server
	 * @param response the response send by the server to the client
	 * @throws ServletException if an error occurred
	 * @throws IOException if an error occurred
	 */
	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		handleRequest(request, response);

	}

	@SuppressWarnings("unchecked")
	private void handleRequest(HttpServletRequest request, HttpServletResponse response) {
		HttpSession session = ((HttpServletRequest)request).getSession();
		Map arguments = new HashMap();
		ApplicationHandler aph = new ApplicationHandler();
		
		String action = (String) request.getParameter("action");
		String url = (String)request.getParameter("url");
		int user_id = ((Integer) session.getAttribute("user_id")).intValue();
		String li_idString = request.getParameter("li_id");
		
		if (li_idString != null){
			int li_id = new Integer(li_idString).intValue();
			arguments.put("li_id", li_id);
		}
		
		String description = (String) request.getParameter("description");
		String tags = (String) request.getParameter("tags");
		
		arguments.put("url", url);
		arguments.put("user_id", user_id);
		arguments.put("description", description);
		
		arguments.put("tags", tags);
		String result = new String();
		try {
			result = aph.handle(action, arguments);
		} catch (StorageException e) {
			
			System.out.println(e.traceBack());
		}
		
		PrintWriter out = null;
		try {
			out = response.getWriter();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		out.print(result);
		out.flush();
		
	}
	/**
	 * Initialization of the servlet. <br>
	 *
	 * @throws ServletException if an error occure
	 */
	public void init() throws ServletException {
		// Put your code here
	}

}
